SystemOrganization addCategory: #'Pier-OmniBrowser-Core'!
SystemOrganization addCategory: #'Pier-OmniBrowser-Nodes'!

ListItemWrapper subclass: #PRStructureItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRStructureItemWrapper methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
= anObject
	^ self species = anObject species
		and: [ self item = anObject item ]! !

!PRStructureItemWrapper methodsFor: 'converting' stamp: 'lr 3/9/2006 11:30'!
asString
	^ self item title! !

!PRStructureItemWrapper methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
contents
	^ self item children collect: [ :each | self class with: each ]! !

!PRStructureItemWrapper methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
hasContents
	^ self item hasChildren! !

!PRStructureItemWrapper methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
hash
	^ self item hash! !

!PRStructureItemWrapper methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
item
	^ item! !

OBNode subclass: #PRPierNode
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

PRPierNode subclass: #PRKernelNode
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
context
	^ context! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
context: aContext
	context := aContext! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
model: aModel
	super model: aModel.
	self context: (PRContext kernel: aModel)! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
name
	^ self model name! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 8/28/2007 09:15'!
structures
	^ Array with: (PRStructureNode on: self model root holder: self)! !

!PRPierNode class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
on: aModel
	^ self new
		model: aModel;
		yourself! !

!PRPierNode methodsFor: 'comparing' stamp: 'lr 8/28/2007 09:15'!
= anObject
	^ self species = anObject species and: [ self model = anObject model ]! !

!PRPierNode methodsFor: 'comparing' stamp: 'lr 8/29/2008 12:01'!
hash
	^ self model hash! !

!PRPierNode methodsFor: 'testing' stamp: 'lr 2/10/2008 23:01'!
isEditable
	^ false! !

!PRPierNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
model
	^ model! !

!PRPierNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
model: aModel
	model := aModel! !

!PRPierNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
text
	^ self model printString! !

PRPierNode subclass: #PRRootNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRRootNode methodsFor: 'accessing' stamp: 'lr 8/28/2007 09:13'!
kernels
	^ self model collect: [ :each | PRKernelNode on: each ]! !

!PRRootNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
name
	^ 'Root'! !

PRPierNode subclass: #PRStructureNode
	instanceVariableNames: 'holder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRStructureNode class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
on: aModel holder: aHolder
	^ (self on: aModel)
		holder: aHolder;
		yourself! !

!PRStructureNode methodsFor: 'actions' stamp: 'lr 9/4/2007 09:50'!
clickLink: aLink in: aBrowser
	aLink isInternal
		ifTrue: [ aBrowser announce: (OBSelectingNode node: (PRStructureNode on: aLink target holder: self holder)) ]
		ifFalse: [
			WebBrowser default
				ifNotNilDo: [ :browser | aLink url asUrl activate ] ]! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
context
	^ self holder context structure: self model! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
context: aContext
	self holder context: aContext! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
holder
	^ holder! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
holder: aHolder
	holder := aHolder! !

!PRStructureNode methodsFor: 'testing' stamp: 'lr 2/10/2008 23:01'!
isEditable
	^ true! !

!PRStructureNode methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:30'!
name
	^ self model title! !

!PRStructureNode methodsFor: 'accessing-dynamic' stamp: 'lr 2/10/2008 23:02'!
structures
	^ self model enumerator collect: [ :each | self class on: each holder: self holder ]! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 9/4/2007 09:51'!
text
	| context browser |
	self model hasDocument
		ifFalse: [ ^ super text ].
	context := thisContext.
	[ context receiver isKindOf: OBDefinitionPanel ]
		whileFalse: [ context := context sender ].
	browser := context receiver browser.
	^ PRTextDocumentWriter new
		action: [ :value | self clickLink: value in: browser ];
		write: self model document! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 10/18/2007 19:08'!
text: aString
	| structure editcontext |
	structure := self context structure.
	editcontext := self context command: model editCommandClass new.
	(editcontext isValid and: [ self context structure class respondsTo: #descriptionDocument ])
		ifFalse: [ ^ super text: aString ].
	editcontext command
		write: (structure class descriptionDocument 
			fromString: aString) 
		using: structure class descriptionDocument;
		execute.
	^ true! !

PRWikiWriter subclass: #PRTextDocumentWriter
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRTextDocumentWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
action
	^ action ifNil: [ action := self defaultAction ]! !

!PRTextDocumentWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
action: aBlock
	action := aBlock! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
anchorAttributesFor: anObject
	^ Array with: (TextColor color: Color darkGray)! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 8/28/2007 09:27'!
boldAttributesFor: anObject
	^ Array with: TextEmphasis bold! !

!PRTextDocumentWriter methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
defaultAction
	^ [ :value | value explore ]! !

!PRTextDocumentWriter methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
defaultStream
	^ TextStream on: Text new! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
headerAttributesFor: anObject
	^ Array with: TextEmphasis bold! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 8/28/2007 09:28'!
italicAttributesFor: anObject
	^ Array with: TextEmphasis italic! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
linkAttributesFor: anObject
	^ Array
		with: (PluggableTextAttribute
			evalBlock: [ self action value: anObject ])
		with: (anObject isBroken
			ifTrue: [ TextColor color: (Color r: 0.5 g: 0.0 b: 0.0) ]
			ifFalse: [ TextColor color: (Color r: 0.0 g: 0.0 b: 0.5) ])
		with: TextEmphasis underlined! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
listAttributesFor: anObject
	^ Array with: (TextIndent tabs: 1)! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 8/28/2007 09:33'!
monospaceAttributesFor: anObject
	^ self preformattedAttributeFor: anObject! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 8/28/2007 09:33'!
preformattedAttributeFor: anObject
	^ Array with: (TextKern kern: 2)! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 8/28/2007 09:34'!
strikethroughAttributesFor: anObject
	^ Array with: TextEmphasis struckOut! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 8/28/2007 09:20'!
subscriptAttributesFor: anObject
	^ #()! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 8/28/2007 09:20'!
superscriptAttributesFor: anObject
	^ #()! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 8/28/2007 09:29'!
underlineAttributesFor: anObject
	^ Array with: TextEmphasis underlined! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitAnchor: anObject
	self
		withAttributes: (self anchorAttributesFor: anObject)
		do: [ super visitAnchor: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 9/27/2007 10:30'!
visitBoldFormat: anObject
	self
		withAttributes: (self boldAttributesFor: anObject)
		do: [ super visitBoldFormat: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 2/10/2008 23:04'!
visitDefinitionList: anObject
	self
		withAttributes: (self listAttributesFor: anObject)
		do: [ super visitDefinitionList: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitHeader: anObject
	self
		withAttributes: (self headerAttributesFor: anObject)
		do: [ super visitHeader: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 9/27/2007 10:30'!
visitItalicFormat: anObject
	self
		withAttributes: (self italicAttributesFor: anObject)
		do: [ super visitItalicFormat: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitLink: anObject
	self
		withAttributes: (self linkAttributesFor: anObject)
		do: [ super visitLink: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 9/27/2007 10:30'!
visitMonospaceFormat: anObject
	self
		withAttributes: (self monospaceAttributesFor: anObject)
		do: [ super visitMonospaceFormat: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitOrderedList: anObject
	self
		withAttributes: (self listAttributesFor: anObject)
		do: [ super visitOrderedList: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitPreformatted: anObject
	self
		withAttributes: (self preformattedAttributeFor: anObject)
		do: [ super visitPreformatted: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 9/27/2007 10:30'!
visitStrikethroughFormat: anObject
	self
		withAttributes: (self strikethroughAttributesFor: anObject)
		do: [ super visitStrikethroughFormat: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 9/27/2007 10:30'!
visitSubscriptFormat: anObject
	self
		withAttributes: (self subscriptAttributesFor: anObject)
		do: [ super visitSubscriptFormat: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 9/27/2007 10:30'!
visitSuperscriptFormat: anObject
	self
		withAttributes: (self superscriptAttributesFor: anObject)
		do: [ super visitSuperscriptFormat: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 9/27/2007 10:30'!
visitUnderlineFormat: anObject
	self
		withAttributes: (self underlineAttributesFor: anObject)
		do: [ super visitUnderlineFormat: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitUnorderedList: anObject
	self
		withAttributes: (self listAttributesFor: anObject)
		do: [ super visitUnorderedList: anObject ]! !

!PRTextDocumentWriter methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:30'!
withAttributes: aCollection do: aBlock
	^ self stream withAttributes: aCollection do: aBlock! !

OBBrowser subclass: #PRBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRBrowser class methodsFor: 'configuration' stamp: 'lr 2/10/2008 22:58'!
defaultMetaNode
	| root kernel structure |
	root := OBMetaNode named: 'Root'.
	kernel := OBMetaNode named: 'Kernel'.
	structure := OBMetaNode named: 'Structure'.
	root childAt: #kernels put: kernel.
	kernel childAt: #structures put: structure.
	structure childAt: #structures put: structure.
	^ root! !

!PRBrowser class methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
defaultRootNode
	^ PRRootNode on: PRKernel instances! !

!PRBrowser class methodsFor: 'initializing' stamp: 'lr 3/9/2006 11:30'!
initialize
	self registerInWorldMenu! !

!PRBrowser class methodsFor: 'configuration' stamp: 'lr 5/28/2007 11:10'!
optionalButtonPanel
	^ nil! !

!PRBrowser class methodsFor: 'initializing' stamp: 'lr 2/10/2008 22:53'!
registerInWorldMenu
	TheWorldMenu registerOpenCommand: (Array with: 'Pier Browser' with: (Array with: self with: #open))! !

!PRBrowser class methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
title
	^ 'Pier Browser'! !

!PRBrowser methodsFor: 'commands' stamp: 'lr 8/28/2007 10:52'!
cmdCommands
	^ (PRCommand withAllConcreteClasses
		reject: [ :each | each isKindOf: PRViewCommand ])
		collect: [ :each | PRWrappedCommand on: each ]! !

!PRBrowser methodsFor: 'commands' stamp: 'lr 1/29/2009 10:03'!
cmdInspect
	^ PRInspectCommand! !

!PRBrowser methodsFor: 'building' stamp: 'lr 2/21/2008 11:37'!
defaultBackgroundColor
	^ Color white! !

OBCommand subclass: #PRInspectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRInspectCommand methodsFor: 'execution' stamp: 'lr 1/29/2009 10:03'!
execute
	target model explore! !

!PRInspectCommand methodsFor: 'accessing' stamp: 'lr 1/29/2009 10:04'!
group
	^ #system! !

!PRInspectCommand methodsFor: 'testing' stamp: 'lr 1/29/2009 10:04'!
isActive
	^ requestor isSelected: target! !

!PRInspectCommand methodsFor: 'accessing' stamp: 'lr 1/29/2009 10:05'!
label
	^ 'inspect'! !

OBCommand subclass: #PRWrappedCommand
	instanceVariableNames: 'commandClass context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRWrappedCommand class methodsFor: 'instance-creation' stamp: 'lr 8/28/2007 09:40'!
on: aClass
	^ self new setCommandClass: aClass! !

!PRWrappedCommand methodsFor: 'execution' stamp: 'lr 8/28/2007 11:07'!
display: aContext
	| result |
	aContext command isQuick
		ifTrue: [ ^ self execute: aContext ].
	result := aContext command asMorph
		addButtons;
		addWindow;
		callInWorld.
	result isNil
		ifFalse: [ self execute: aContext ]! !

!PRWrappedCommand methodsFor: 'execution' stamp: 'lr 2/10/2008 23:07'!
execute
	PRCurrentContext
		use: target holder
		during: [ self display: context ].
	requestor browser signalRefresh! !

!PRWrappedCommand methodsFor: 'execution' stamp: 'lr 9/12/2007 18:18'!
execute: aContext
	target context: (aContext command execute; answer).
	aContext command answer command isView
		ifFalse: [ self display: aContext command answer ]! !

!PRWrappedCommand methodsFor: 'accessing' stamp: 'lr 1/29/2009 10:04'!
group
	^ #pier! !

!PRWrappedCommand methodsFor: 'testing' stamp: 'lr 1/29/2009 10:22'!
isActive
	^ context notNil
		and: [ context structure viewCommandClass ~= commandClass
		and: [ requestor isSelected: target ] ]! !

!PRWrappedCommand methodsFor: 'accessing' stamp: 'lr 8/28/2007 10:57'!
keystroke
	^ commandClass accessKey! !

!PRWrappedCommand methodsFor: 'accessing' stamp: 'lr 8/28/2007 10:51'!
label
	^ commandClass shortLabel asLowercase , (context command isQuick ifTrue: [ '' ] ifFalse: [ '...' ])! !

!PRWrappedCommand methodsFor: 'accessing' stamp: 'lr 8/28/2007 09:46'!
on: anObject for: aRequestor
	^ (super on: anObject for: aRequestor) setCommandClass: commandClass! !

!PRWrappedCommand methodsFor: 'initialization' stamp: 'lr 1/29/2009 10:21'!
setCommandClass: aClass
	commandClass := aClass.
	context := ((target isKindOf: PRStructureNode) and: [ commandClass isValidIn: target context ])
		ifTrue: [ target context command: commandClass new ]! !

MAElementMorph subclass: #PRStructureMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRStructureMorph methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
buildMorphEditor
	^ (SimpleHierarchicalListMorph
		on: self
		list: #root
		selected: #selected
		changeSelected: #selected:
		menu: nil
		keystroke: nil)
			hResizing: #spaceFill;
			borderColor: #inset;
			borderWidth: 2;
			expandAll;
			yourself! !

!PRStructureMorph methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:30'!
root
	^ Array with: (PRStructureItemWrapper with: self model context root)! !

!PRStructureMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
selected
	^ PRStructureItemWrapper with: self value! !

!PRStructureMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
selected: aWrapper
	self value: (aWrapper ifNotNil: [ aWrapper item ]).
	self changed: #selected! !
PRBrowser initialize!
